EnergyFuture Class Reference
Financial instruments

Energy future. More...

`#include <ql/experimental/commodities/energyfuture.hpp>`

Inheritance diagram for EnergyFuture:
[legend]

## Public Member Functions

| EnergyFuture (Integer buySell, const Quantity &quantity, const CommodityUnitCost &tradePrice, const ext::shared_ptr< CommodityIndex > &index, const CommodityType &commodityType, const ext::shared_ptr< SecondaryCosts > &secondaryCosts)
bool | isExpired () const
| returns whether the instrument might have value greater than zero.
Quantity | quantity () const
const CommodityUnitCost & | tradePrice () const
ext::shared_ptr< CommodityIndex > | index () const
Public Member Functions inherited from EnergyCommodity
| EnergyCommodity (const CommodityType &commodityType, const ext::shared_ptr< SecondaryCosts > &secondaryCosts)
const CommodityType & | commodityType () const
void | setupArguments (PricingEngine::arguments *) const
void | fetchResults (const PricingEngine::results *) const
Public Member Functions inherited from Commodity
| Commodity (const ext::shared_ptr< SecondaryCosts > &secondaryCosts)
const ext::shared_ptr< SecondaryCosts > & | secondaryCosts () const
const SecondaryCostAmounts & | secondaryCostAmounts () const
const PricingErrors & | pricingErrors () const
void | addPricingError (PricingError::Level errorLevel, const std::string &error, const std::string &detail="") const
Public Member Functions inherited from Instrument
Real | NPV () const
| returns the net present value of the instrument.
Real | errorEstimate () const
| returns the error estimate on the NPV when available.
const Date & | valuationDate () const
| returns the date the net present value refers to.
template<typename T >
T | result (const std::string &tag) const
| returns any additional result returned by the pricing engine.
const std::map< std::string, boost::any > & | additionalResults () const
| returns all additional result returned by the pricing engine.
void | setPricingEngine (const ext::shared_ptr< PricingEngine > &)
| set the pricing engine to be used. More...
Public Member Functions inherited from LazyObject
void | update ()
void | recalculate ()
void | freeze ()
void | unfreeze ()
void | alwaysForwardNotifications ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< iterator, bool > | registerWith (const ext::shared_ptr< Observable > &)
void | registerWithObservables (const ext::shared_ptr< Observer > &)
Size | unregisterWith (const ext::shared_ptr< Observable > &)
void | unregisterWithAll ()
virtual void | deepUpdate ()

## Protected Member Functions

void | performCalculations () const
Protected Member Functions inherited from EnergyCommodity
Real | calculateUnitCost (const CommodityType &commodityType, const CommodityUnitCost &unitCost, const Date &evaluationDate) const
void | calculateSecondaryCostAmounts (const CommodityType &commodityType, Real totalQuantityValue, const Date &evaluationDate) const
Protected Member Functions inherited from Instrument
void | calculate () const
virtual void | setupExpired () const
Protected Member Functions inherited from LazyObject

## Protected Attributes

Integer | buySell_
Quantity | quantity_
CommodityUnitCost | tradePrice_
ext::shared_ptr< CommodityIndex > | index_
Protected Attributes inherited from EnergyCommodity
CommodityType | commodityType_
Protected Attributes inherited from Commodity
ext::shared_ptr< SecondaryCosts > | secondaryCosts_
PricingErrors | pricingErrors_
SecondaryCostAmounts | secondaryCostAmounts_
Protected Attributes inherited from Instrument
Real | NPV_
Real | errorEstimate_
Date | valuationDate_
std::map< std::string, boost::any > | additionalResults_
ext::shared_ptr< PricingEngine > | engine_
Protected Attributes inherited from LazyObject
bool | calculated_
bool | frozen_
bool | alwaysForward_

## Additional Inherited Members

Public Types inherited from EnergyCommodity
enum | DeliverySchedule { Constant, Window, Hourly, Daily, Weekly, Monthly, Quarterly, Yearly }
enum | QuantityPeriodicity { Absolute, PerHour, PerDay, PerWeek, PerMonth, PerQuarter, PerYear }
enum | PaymentSchedule { WindowSettlement, MonthlySettlement, QuarterlySettlement, YearlySettlement }
Public Types inherited from Observer
typedef boost::unordered_set< ext::shared_ptr< Observable > > | set_type
typedef set_type::iterator | iterator
Static Protected Member Functions inherited from EnergyCommodity
static Real | calculateFxConversionFactor (const Currency &fromCurrency, const Currency &toCurrency, const Date &evaluationDate)
static Real | calculateUomConversionFactor (const CommodityType &commodityType, const UnitOfMeasure &fromUnitOfMeasure, const UnitOfMeasure &toUnitOfMeasure)

## Detailed Description

Energy future.

## Member Function Documentation

## performCalculations()

void performCalculations | ( |  | ) | const

protected virtual

In case a pricing engine is not used, this method must be overridden to perform the actual calculations and set any needed results. In case a pricing engine is used, the default implementation can be used.

Reimplemented from Instrument.